# generated by datamodel-codegen:
#   filename:  zillaiot_component_config.schema.json
#   timestamp: 2021-04-08T01:42:06+00:00

from __future__ import annotations

from typing import Any, Dict, List, Union

from pydantic import BaseModel


class Status(BaseModel):
    default: int
    status: int
    msg: str


class Status1(BaseModel):
    default: int
    status: int
    msg: str


class Status2(BaseModel):
    default: int
    status: int
    msg: str


class ChecklistItems(BaseModel):
    sholve: List[Union[int, int]]
    gas: List[Union[int, int]]
    oil: List[Union[int, int]]
    motor: List[Union[int, int]]
    plate_truck: str
    invoice: str
    status: List
    timestamp: str


class Overseer(BaseModel):
    name: str
    id: str
    checklist_items: ChecklistItems


class Overseer1(BaseModel):
    chechlist_items: Dict[str, Any]


class Events(BaseModel):
    timestamp: str
    status: Dict[str, Any]
    overseer: Overseer1


class Tracker(BaseModel):
    name: str
    status: List[Union[Status, Status1, Status2]]
    overseer: Overseer
    events: Events


class Noth(BaseModel):
    latitude: int
    longitude: int


class West(BaseModel):
    latitude: int
    longitude: int


class Soulth(BaseModel):
    latitude: int
    longitude: int


class Est(BaseModel):
    latitude: int
    longitude: int


class Perimeter(BaseModel):
    noth: Noth
    west: West
    soulth: Soulth
    est: Est


class Speed(BaseModel):
    max_allow: int
    min_allow: int


class Events1(BaseModel):
    timestamp: str
    name: str
    perimeter: Perimeter
    speed: Speed


class Gps(BaseModel):
    name: str
    status: List[Union[str, str]]
    events: Events1


class Event(BaseModel):
    timestamp: str
    name: str
    file_name: str
    status: str


class Video(BaseModel):
    name: str
    base_path: str
    time_stamp: str
    prefix_metadata: str
    record_max_time_sec: int
    interval_record_in_secs: int
    status: List[Union[str, str, str, str, str]]
    events: List[Event]


class Event1(BaseModel):
    name: str
    timestamp: str
    file_name: str
    status: str


class Photo(BaseModel):
    name: str
    base_path: str
    time_stamp: str
    prefix_metadata: str
    interval_photo_in_secs: int
    status: List[Union[str, str, str, str]]
    events: List[Event1]


class Config(BaseModel):
    components: List
    tracker: Tracker
    gps: Gps
    video: Video
    photo: Photo


class ZillaIot_Config(BaseModel):
    kind: str
    mac: str
    key: str
    timestamp: str
    config: Config
